package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.XM;

/**
 * 实体[ZCMX] 数据对象
 */
@TableName(value = "T_ZCMX",resultMap = "ZCMXResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class ZCMX extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private XM xm;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String xmid;
    @TableId(value= "zcmxid",type=IdType.UUID)//指定主键生成策略
    private String zcmxid;
    private String zcmxname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[项目标识]
     *  @param xmid
     */
    public void setXmid(String xmid){
        if(StringUtils.isEmpty(xmid))
            xmid=null;
        this.xmid = xmid;
        this.set("xmiddirtyflag",true);
    }
    /**
     *  获取属性值[项目标识]
     */
    public String getXmid(){
        return this.xmid;
    }
    /**
     *  重置属性值[项目标识]
     */
    public void resetXmid(){
        this.set("xmiddirtyflag",false);
        this.xmid = null;
    }
    /**
     *  设置属性值[支出明细标识]
     *  @param zcmxid
     */
    public void setZcmxid(String zcmxid){
        if(StringUtils.isEmpty(zcmxid))
            zcmxid=null;
        this.zcmxid = zcmxid;
        this.set("zcmxiddirtyflag",true);
    }
    /**
     *  获取属性值[支出明细标识]
     */
    public String getZcmxid(){
        return this.zcmxid;
    }
    /**
     *  重置属性值[支出明细标识]
     */
    public void resetZcmxid(){
        this.set("zcmxiddirtyflag",false);
        this.zcmxid = null;
    }
    /**
     *  设置属性值[支出明细名称]
     *  @param zcmxname
     */
    public void setZcmxname(String zcmxname){
        if(StringUtils.isEmpty(zcmxname))
            zcmxname=null;
        this.zcmxname = zcmxname;
        this.set("zcmxnamedirtyflag",true);
    }
    /**
     *  获取属性值[支出明细名称]
     */
    public String getZcmxname(){
        return this.zcmxname;
    }
    /**
     *  重置属性值[支出明细名称]
     */
    public void resetZcmxname(){
        this.set("zcmxnamedirtyflag",false);
        this.zcmxname = null;
    }
     /**
     *  获取主实体关联数据[XM]
     */
    public XM getXm() {
        return xm;
    }
    /**
     *  设置主实体关联数据[XM]
     */
    public void setXm(XM xm) {
        this.xm = xm;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetUpdatedate();
        resetUpdateman();
        resetXmid();
        resetZcmxid();
        resetZcmxname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public ZCMX copyTo(ZCMX targetEntity)
	{
		BeanCopier copier=BeanCopier.create(ZCMX.class, ZCMX.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetZcmxid();
		return targetEntity;
	}
}